#ifndef _COMMON_H
#define _COMMON_H 1

// constants
#define FEATURE_SAMPLES (44100 * 30)
#define MFCC_WIN_LEN 1024     /* about 25ms */
#define MFCC_FLOOR0_DATA_LEN 1024
#define MFCC_COEFFICIENTS 32
#define MFCC_OVERLAP 2
#define MFCC_MOMENTS 5

#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <complex>

struct Sample {
	std::vector<double> samples;
	double length;
	std::map<std::string, std::vector<double> > descriptors;
};

static inline double hz_to_mel(double hz)
{
	return 1127.01048 * log(1.0 + hz / 700.0);
}

static inline double mel_to_hz(double mel)
{
	return 700.0 * (exp(mel / 1127.01048) - 1.0);
}

// correct?
static inline double hz_to_bin(double hz)
{
	return (MFCC_WIN_LEN / 2 + 1) * hz / 44100.0 - 0.5;
}

static inline double bin_to_hz(double bin)
{
	return (bin + 0.5) * 44100.0 / (MFCC_WIN_LEN / 2 + 1);
}

#endif /* !defined(_COMMON_H) */
