adhoc <- read.csv("matrix.csv", header=TRUE)
pc <- prcomp(adhoc, scale=TRUE)

mdat <- matrix(pc$rotation, nrow=6, ncol=6, dimnames=list(c("Length","Mean-square ratio","Steepness","Centroid","Zero crossings","Zero crossings (Schmitt)"), c("PC1","PC2","PC3","PC4","PC5","PC6")))
write.csv(mdat, "pca-scaled.csv")

write.csv(summary(pc)$importance, "pca-scaled-sd.csv")

write(pc$rotation, "pca-scaled-rot.txt")
write(pc$center, "pca-scaled-center.txt")
write(pc$scale, "pca-scaled-scale.txt")
