<?php
/**
 * This script finds the number of potential duplicates 
 * when only looking at the file names.
 * 
 * @author Vegard Andreas Larsen <vegarl@stud.ntnu.no>
 */
require_once('include/include.php');
$oDB = CDatabase::Get();

include('duplicate_finder.php');

$sqlSelectFile = "SELECT ixFile, sPath FROM tblFile ORDER BY ixFile ASC";
$rgoFiles = $oDB->extended->GetAssoc($sqlSelectFile, null, null, null, 
    MDB2_FETCHMODE_ASSOC, false);

/*
 * Pre-process the file names into tokens, since we
 * will be doing about 45M checks.
 */
$rgoTokens = array();
$ixFileMax = 0;
foreach ($rgoFiles as $ixFile => $sPath)
{
    $rgoTokens[$ixFile] = tokenize_filename(filename($sPath));
    $ixFileMax = $ixFile;
}

/*
 * Start counting duplicates.
 */
$cDupCount = 0;
$rgoMatch = array();
for ($i = 0; $i <= $ixFileMax; $i++)
{
    // Progress indicator
    // echo "$i\t$cDupCount\n";
    
    if (!isset($rgoFiles[$i])) continue;
    
    for ($j = $i + 1; $j <= $ixFileMax; $j++)
    {
        if (!isset($rgoFiles[$j])) continue;
    
        if (compare_filename($rgoFiles[$i], $rgoFiles[$j], 
            $rgoTokens[$i], $rgoTokens[$j]))
        {
            $cDupCount++;
        }
    }
}
echo $cDupCount;
?>
