<?php
/**
 * This script picks 500 000 random files to compare, and checks
 * if they have file names that match. The file names that match
 * printed to stdout, and was verified by a human.
 * 
 * @author Vegard Andreas Larsen <vegarl@stud.ntnu.no>
 */
require_once('include/include.php');
$oDB = CDatabase::Get();
$oSmarty = CSmarty::Get();

include('duplicate_finder.php');

$sqlSelectFile = "SELECT ixFile, sPath FROM tblFile";
$rgoFiles = $oDB->extended->GetAssoc($sqlSelectFile, null, null, null, MDB2_FETCHMODE_ASSOC, false);

$rgoTokens = array();
foreach ($rgoFiles as $ixFile => $sPath)
{
    $rgoTokens[$ixFile] = tokenize_filename(filename($sPath));
}

$cNumMatch = 0;
for ($i = 0; $i < 500000; $i++)
{
    $x = rand(0, count($rgoFiles));        
    $y = rand(0, count($rgoFiles));
    while ($x == $y || !isset($rgoFiles[$x]) || !isset($rgoFiles[$y]))
    {
        $x = rand(0, count($rgoFiles));        
        $y = rand(0, count($rgoFiles));
    }
    if (compare_filename($rgoFiles[$x], $rgoFiles[$y], $rgoTokens[$x], $rgoTokens[$y]))
    {
        $cNumMatch++;
        echo "<br/>\n".str_replace("/mnt/media/", '', $rgoFiles[$x])."<br/>\n";
        echo str_replace("/mnt/media/", '', $rgoFiles[$y])."<br/>\n";
    }
}

echo $cNumMatch."\n";
?>
