<?php
/**
 * This script finds the number of correct duplicates,
 * divided into partitions of 100 duplicates, for each
 * individual descriptor and each combined solution.
 *
 * @author Vegard Andreas Larsen <vegarl@stud.ntnu.no>
 */
require_once('include/include.php');
$cNumRows = 1000;

/*
 * HTML table headers
 */
?>
<table border="1">
  <tr>
    <th>Type/method</th>
    <th>Name</th>
<?php
    for ($i = 1; $i <= 10; $i++)
    {
        echo "<th>".(($i-1)*100+1)."-".($i*100)."</th>\n";
    }
?>
    <th>%</th>
    <th>Errors in first <?= $cNumRows ?></th>
    <th>First error at #</th>
  </tr>
<?php
$oDB = CDatabase::Get();

$cNumFetchRows = $cNumRows;


/*
 * Get a list of the verified duplicates.
 */
$sql = "SELECT * FROM tblVerifiedMatch";
$rgoVerified = $oDB->extended->GetAll($sql);
$rgVerified = array();
foreach ($rgoVerified as $o)
{
    $rgVerified[$o->ixFile1][$o->ixFile2] = true; 
}
$rgoVerified = null;
unset($rgoVerified);

function display($ixMethod, $sTitle, $rgoScores)
{
    global $rgVerified;
    global $cNumRows;
?>
  <tr>
    <td><?= $ixMethod ?></td>
    <td><?= $sTitle ?></td>
<?php

    $rgoScoresVerified = array();
    $rgoScoresWrong = array();
    $i = 0; 
    $cWrong = 0;
    $ixFirstWrong = 0;
    $g = 0; // counter
    $cWrongInPartition = 0;
    for ($z = 0; $z < $cNumRows; $z++)
    {
        $o = $rgoScores[$z];
        if (isset($rgoScores[$z]) && 
            $rgVerified[$o->ixFile1][$o->ixFile2])
        {
            $rgoScoresVerified[] = $o;
        }
        else
        { 
            $rgoScoresWrong[] = $o;
            if (empty($ixFirstWrong))
                $ixFirstWrong = $i;
            if ($i < $cNumRows)
            {
                $cWrong++;
                $cWrongInPartition++;
            }
        }
        unset($rgoScores[$k]);
        $i++;
        if ($i % 100 == 0) 
        {
            $g++;
            echo "<td>$cWrongInPartition</td>\n";
            $cWrongInPartition = 0;
        }    
    }

?>
    <td><?= $cWrong / $cNumRows ?></td>
    <td><?= $cWrong ?></td>
    <td><?= $ixFirstWrong ?></td>
  </tr>
<?php
}

/*
 * A list of the names of all the scoring methods.
 */
$sqlSelectTitles = "SELECT ixScoreMethod, sTitle FROM tblScoreMethods";
$rgsTitle = $oDB->extended->GetAssoc($sqlSelectTitles, null, null, null, 
    MDB2_FETCHMODE_ASSOC, false);
// Get scores for all the scoring methods
$rgixScoreMethods = array_keys($rgsTitle);

/*
 * Now let's examine them.
 */
$sql = "SELECT dblScore, dblSD, ixFile1, ixFile2 ".
    "FROM tblSummedScore ".
    "WHERE ixScoreMethod = ? ".
    "ORDER BY dblScore DESC, dblSD ASC ".
    "LIMIT 0, $cNumFetchRows";

foreach ($rgixScoreMethods as $ixScoreMethod)
{    
    $sTitle = $rgsTitle[$ixScoreMethod];
    $rgoScores = $oDB->extended->GetAll($sql, null, 
        array($ixScoreMethod), array('integer'));
    display('C'.$ixScoreMethod, $sTitle, $rgoScores);
}

/*
 * Let's look at the individual descriptors
 */

$sqlSelectTypes = "SELECT ixType, sType FROM tblType";
$rgoTypes = $oDB->extended->GetAssoc($sqlSelectTypes, null, null, null, 
    MDB2_FETCHMODE_ASSOC, false);

$sql = "SELECT ixFile1, ixFile2, dblScore ".
    "FROM tblScore WHERE ixType = ? ".
    "ORDER BY dblScore DESC LIMIT 0, $cNumFetchRows";

foreach ($rgoTypes as $ixType => $sType)
{
    $rgoScores = $oDB->extended->GetAll($sql, null, 
        array($ixType), array('integer'));
    display('I'.$ixType, $sType, $rgoScores);
}

?>
</table>
